﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Prevodnik_jednotiek
{
    public class Converts
    {
        private static Converts converts;

        /*Lazy Load Pattern*/
        public static Converts Instance()
        {
            if (converts == null)
            {
                converts = new Converts();
            }
            return converts;
        }

        public double getMeasureValue(double value,string firstType, string secondType)
        {
            Dictionary<string, int> weightUnits = new Dictionary<string, int>();
            weightUnits.Add("mm", 10);
            weightUnits.Add("cm", 10);
            weightUnits.Add("dm", 10);
            weightUnits.Add("m", 1000);
            weightUnits.Add("km", 1);

            return customUnitConvert(value, firstType, secondType, weightUnits);

        }
        public double getWeightValue(double value, string firstType, string secondType)
        {
            Dictionary<string, int> weightUnits = new Dictionary<string, int>();
            weightUnits.Add("g", 10);
            weightUnits.Add("dkg", 100);
            weightUnits.Add("kg", 100);
            weightUnits.Add("q", 10);
            weightUnits.Add("t", 1);

            return customUnitConvert(value, firstType, secondType, weightUnits);

        }
        public double getDataCapacityValue(double value,string firstType, string secondType)
        {
            Dictionary<string, int> dataCapacityUnits = new Dictionary<string, int>();
            dataCapacityUnits.Add("B", 1000);
            dataCapacityUnits.Add("kB", 1000);
            dataCapacityUnits.Add("MB", 1000);
            dataCapacityUnits.Add("GB", 1000);
            dataCapacityUnits.Add("TB", 1);

            return customUnitConvert(value, firstType, secondType, dataCapacityUnits);
        }

        private double customUnitConvert(double value, string firstType, string secondType, Dictionary<string,int> units)
        {

            double result = 0;
            /*Ta ista jednotka*/
            if (firstType == secondType)
            {
                result = value;
            }

            /*Hladame indexy typov*/
            else
            {
                int firstIndex = 0;
                int secondIndex = 0;
                int j = 0;
                foreach (var item in units)
                {
                    if (item.Key == firstType)
                        firstIndex = j;
                    else if (item.Key == secondType)
                        secondIndex = j;
                    j++;
                }
                // vacsi typ je prvy
                if (firstIndex > secondIndex)
                {
                    result = value;
                    for (int i = secondIndex; i < firstIndex; i++)
                    {
                        result *= units.Values.ElementAt(i);
                    }
                }
                //vacsi typ je druhy
                else if (secondIndex > firstIndex)
                {
                    result = value;
                    for (int i = firstIndex; i < secondIndex; i++)
                    {
                        result /= units.Values.ElementAt(i);
                    }
                }
            }
            return result;
        }
    }
}